// Etape 1 :
// Importation des packages Java 2
import java.applet.Applet;
import java.awt.*;

// Etape 2 :
// Importation des packages Java 3D
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;

public class Rotation2 extends Applet {

  public Rotation2() {
    this.setLayout(new BorderLayout());

    // Etape 3 :
    // Creation du Canvas 3D
    Canvas3D canvas3D = new Canvas3D(SimpleUniverse.getPreferredConfiguration());

    this.add(canvas3D, BorderLayout.CENTER);

    // Etape 4 :
    // Creation d'un objet SimpleUniverse
    SimpleUniverse simpleU = new SimpleUniverse(canvas3D);

    // Etape 5 :
    // Positionnement du point d'observation pour avoir une vue correcte de la
    // scene 3D
    simpleU.getViewingPlatform().setNominalViewingTransform();

    // Etape 6 :
    // Creation de la scene 3D qui contient tous les objets 3D que l'on veut
    // visualiser
    BranchGroup scene = createSceneGraph();

    // Etape 7 :
    // Compilation de la scene 3D
    scene.compile();

    // Etape 8:
    // Attachement de la scene 3D a l'objet SimpleUniverse
    simpleU.addBranchGraph(scene);
  }

  /**
   * Creation de la scene 3D
   * @return scene 3D
   */
  public BranchGroup createSceneGraph() {
    // Creation de l'objet racine (parent) qui contiendra tous les autres
    // noeuds
    BranchGroup parent = new BranchGroup();

    // Creation de la transformation (rotation de 45 degres autour de
    // l'axe (1, 1, 0)
    Transform3D rotation = new Transform3D();
    AxisAngle4f axis = new AxisAngle4f(1, 1, 0, (float)(45f * Math.PI/180f));
    rotation.set(axis);

    // Creation du groupe qui va contenir la transformation (rotation)
    TransformGroup transformGroup = new TransformGroup(rotation);

    // Creation de l'objet pour lequel on va appliquer cette transformation
    // (rotation)
    ColorCube cube = new ColorCube(0.3f);

    // Le cube est fils du TransformGroup qui contient la rotation :
    // on l'ajoute donc a l'objet TransformGroup
    transformGroup.addChild(cube);

    // L'objet TransformGroup est le fils de l'objet racine (BranchGroup)
    parent.addChild(transformGroup);

    return parent;
  }

  /**
   * Etape 9 :
   * Methode main() nous permettant d'utiliser cette classe comme une applet
   * ou une application.
   * @param args arguments
   */
  public static void main(String[] args) {
    Frame frame = new MainFrame(new Rotation2(), 256, 256);
  }
}
