// Etape 1 :
// Importation des packages Java 2
import java.applet.Applet;
import java.awt.*;

// Etape 2 :
// Importation des packages Java 3D
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;

public class RotationsMultiples extends Applet {

  public RotationsMultiples() {
    this.setLayout(new BorderLayout());

    // Etape 3 :
    // Creation du Canvas 3D
    Canvas3D canvas3D = new Canvas3D(SimpleUniverse.getPreferredConfiguration());

    this.add(canvas3D, BorderLayout.CENTER);

    // Etape 4 :
    // Creation d'un objet SimpleUniverse
    SimpleUniverse simpleU = new SimpleUniverse(canvas3D);

    // Etape 5 :
    // Positionnement du point d'observation pour avoir une vue correcte de la
    // scene 3D
    simpleU.getViewingPlatform().setNominalViewingTransform();

    // Etape 6 :
    // Creation de la scene 3D qui contient tous les objets 3D que l'on veut
    // visualiser
    BranchGroup scene = createSceneGraph();

    // Etape 7 :
    // Compilation de la scene 3D
    scene.compile();

    // Etape 8:
    // Attachement de la scene 3D a l'objet SimpleUniverse
    simpleU.addBranchGraph(scene);
  }

  /**
   * Creation de la scene 3D
   * @return scene 3D
   */
  public BranchGroup createSceneGraph() {
    // Creation de l'objet racine (parent) qui contiendra tous les autres
    // noeuds
    BranchGroup parent = new BranchGroup();

    // Creation de la premiere rotation de 45 degres autour de l'axe X
    Transform3D rotationX = new Transform3D();
    rotationX.rotX(45f * Math.PI/180f);

    // Creation de la deuxieme rotation de 45 degres autour de l'axe Y
    Transform3D transform = new Transform3D();
    transform.rotY(45f * Math.PI/180f);

    // Cumul des deux rotations (rotation de 45 degres autour de l'axe X
    // d'abord puis rotation de 45 degres autour de l'axe Y ensuite)
    transform.mul(rotationX);

    // Creation du groupe qui va contenir la transformation globale
    TransformGroup transformGroup = new TransformGroup(transform);

    // Creation de l'objet pour lequel on va appliquer cette transformation
    // (double rotation)
    ColorCube cube = new ColorCube(0.3f);

    // Le cube est fils du TransformGroup qui contient la transformation :
    // on l'ajoute donc a l'objet TransformGroup
    transformGroup.addChild(cube);

    // L'objet TransformGroup est le fils de l'objet racine (BranchGroup)
    parent.addChild(transformGroup);

    return parent;
  }

  /**
   * Etape 9 :
   * Methode main() nous permettant d'utiliser cette classe comme une applet
   * ou une application.
   * @param args arguments
   */
  public static void main(String[] args) {
    Frame frame = new MainFrame(new RotationsMultiples(), 256, 256);
  }
}
